package  
{
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.events.IOErrorEvent;
	import flash.events.Event;
	/**
	 * ...
	 * @author Pimgd
	 */
	public class DialogueVariables extends CustomVariableHolder
	{
		private var dialogueToLoad:String = "";
		private var diagloader:URLLoader;
		private var dialogueurlr:URLRequest;
		public function DialogueVariables(G:Object, M:Main) 
		{
			super(G, M);
			diagloader = new URLLoader();
			diagloader.addEventListener(Event.COMPLETE, this.onDialogueLoad);
			diagloader.addEventListener(IOErrorEvent.IO_ERROR, this.dialogueLoadFail);
		}
		
		public function registerVariables(v:VariableManager):void {
			v.registerVariableWrite("da.dialogue.load", new FunctionObject(addLineChangeListener, this, []));
		}
		
		public function addLineChangeListener(dialoguepath:String):void {
			dialogueToLoad = dialoguepath;
			m.addLineChangeListener(new FunctionObject(onLineChange, this, []));
		}
		
		public function onLineChange(...args):void {
			loadDialogue(dialogueToLoad);
		}
		
		public function loadDialogue(value:String):void {
			dialogueurlr = new URLRequest("Mods/"+m.lastLoadedCData+"/"+dialogueToLoad);
			diagloader.load(dialogueurlr);
		}
		
		public function onDialogueLoad(e:Event = null):void {
			g.dialogueControl.loadCustomDialogue(e.target.data);
		}
		
		public function dialogueLoadFail(e:Event = null):void {
			m.displayMessageRed("Couldn't find Dialogue file: " + dialogueurlr.url);
		}
	}

}