package 
{
	import flash.display.MovieClip;
	import flash.display.Graphics;

	// Original gracefully coded by ModGuy, Many thanks man !
	public class MTProgressBar extends MovieClip {

		private var mtpbColor:int;
		private var mtpbWidth:int;
		private var mtpbHeight:int;
		private var minimumValue:int = 0;
		private var maximumValue:int = 100;
		private var mtpbValue:int = 0;

		public function MTProgressBar(_wid:int, _hei:int, _min:int, _max:int, _col:int) {

			mtpbWidth = _wid;
			mtpbHeight = _hei;
			
			if (_min == _max) {
				_max = _min + 1;
			}
			
			minimumValue = Math.min(_min, _max);
			maximumValue = Math.max(_min, _max);
			mtpbValue = _min;
			mtpbColor = _col;
			refresh();
		}

		public function setValue(_val:int):void	{
			mtpbValue = Math.max(Math.min(_val, maximumValue), minimumValue);
			refresh();
		}

		public function refresh():void	{

			//http://help.adobe.com/en_US/FlashPlatform/reference/actionscript/3/flash/display/Graphics.html
			var graph:Graphics = this.graphics;

			//Draw red fill that is fully opaque.
			graph.clear();
			graph.beginFill(mtpbColor, 1);
			graph.lineStyle(0, 0, 0);
			graph.drawRect(0,0, ((mtpbValue - minimumValue) * mtpbWidth / (maximumValue - minimumValue)) , mtpbHeight);
			graph.endFill();
		}
	}
}